/*
 * Created on 04-jul-2005
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.gvsig.geoprocessing.gui.operationpanels;

import javax.swing.JPanel;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.JButton;

import java.awt.Component;
import java.awt.FlowLayout;
import java.io.File;

import javax.swing.JRadioButton;

import com.hardcode.gdbms.engine.data.DataSource;
import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.layers.FBitSet;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.layerOperations.AlphanumericData;
import com.iver.cit.gvsig.fmap.layers.layerOperations.Selectable;
import com.iver.utiles.GenericFileFilter;
/**
 * @author jmorell
 */
public class GeoProcessingBufferPanel extends JPanel {

	/**
     * 
     */
    private static final long serialVersionUID = 1L;
    private JLabel jLabel = null;
	private JCheckBox jCheckBox = null;
	private JComboBox jComboBox = null;
	private JTextField jTextField = null;
	private JButton jButton = null;
	private JRadioButton jRadioButton = null;
	private JTextField jTextField1 = null;
	private JRadioButton jRadioButton1 = null;
	private JComboBox jComboBox1 = null;
	private ButtonGroup buttonGroup = null;
	private JLabel jLabel3 = null;
	private JLabel jLabel1 = null;
	private FLayers layers = null;
    private JComboBox endType = null;
    private JLabel endTypeLabel = null;
    private JCheckBox dissolveEntitiesJCheckBox = null;
    /**
	 * This is the default constructor
	 */
	/*public GeoProcessingBufferPanel() {
		super();
		initialize();
	}*/
	/**
	 * This constructor initializes the set of layers
	 */
	public GeoProcessingBufferPanel(FLayers layers) {
		super();
		this.layers = layers;
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		endTypeLabel = new JLabel();
		endTypeLabel.setBounds(4, 144, 213, 21);
		endTypeLabel.setText(PluginServices.getText(this,"Numero_de_segmentos_por_cuadrante") + ":");
		jLabel1 = new JLabel();
		jLabel3 = new JLabel();
		jLabel = new JLabel();
		this.setLayout(null);
		this.setSize(406, 229);
		jLabel.setText(PluginServices.getText(this,"Areas_de_influencia._Introduccion_de_datos") + ":");
		jLabel.setBounds(4, 5, 239, 21);
		jLabel3.setText(PluginServices.getText(this,"Cobertura_de_entrada") + ":");
		jLabel3.setBounds(4, 32, 126, 21);
		jLabel1.setText(PluginServices.getText(this,"Cobertura_de_salida") + ":");
		jLabel1.setBounds(4, 200, 118, 21);
		this.add(jLabel, null);
		this.add(jLabel3, null);
		this.add(getJComboBox(), null);
		this.add(getJCheckBox(), null);
		this.add(getJRadioButton(), null);
		this.add(getJRadioButton1(), null);
		this.add(getJComboBox1(), null);
		this.add(getJTextField1(), null);
		this.add(jLabel1, null);
		this.add(getJTextField(), null);
		this.add(getJButton(), null);
		this.add(getEndType(), null);
		this.add(endTypeLabel, null);
		this.add(getDissolveEntitiesJCheckBox(), null);
		confButtonGroup();
        jComboBox.setSelectedIndex(0);
        initSelectedItemsJCheckBox();
		jRadioButton.setSelected(true);
		jComboBox1.setEnabled(false);
	}
    private String[] getLayerNames() {
        String[] layerNames = new String[layers.getLayersCount()];
        for (int i=0;i<layers.getLayersCount();i++) {
            layerNames[i] = layers.getLayer(i).getName();
        }
        return layerNames;
    }
    private String[] getFieldNames() {
        AlphanumericData lyr = (AlphanumericData)(layers.getLayer((String)jComboBox.getSelectedItem()));
        DataSource ds;
        String[] fieldNames = null;
        try {
            ds = lyr.getRecordset();
            fieldNames = new String[ds.getFieldCount()];
            for (int i = 0; i < ds.getFieldCount(); i++) {
                fieldNames[i] = ds.getFieldName(i);
            }
        } catch (DriverException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (com.hardcode.gdbms.engine.data.driver.DriverException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return fieldNames;
    }
    private void initSelectedItemsJCheckBox() {
        Selectable inputSelectable = (Selectable)(layers.getLayer((String)jComboBox.getSelectedItem()));
        FBitSet fBitSet = inputSelectable.getSelection();
        if (fBitSet.cardinality()==0) {
            jCheckBox.setEnabled(false);
        } else {
            jCheckBox.setEnabled(true);
        }
        jCheckBox.setSelected(false);
    }
	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText(PluginServices.getText(this,"Usar_solamente_los_elementos_seleccionados"));
			jCheckBox.setBounds(4, 59, 271, 21);
		}
		return jCheckBox;
	}
	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJComboBox() {
		if (jComboBox == null) {
            jComboBox = new JComboBox();
            DefaultComboBoxModel defaultModel = new DefaultComboBoxModel(getLayerNames());
            jComboBox.setModel(defaultModel);
			jComboBox.setBounds(142, 32, 260, 21);
			jComboBox.addItemListener(new java.awt.event.ItemListener() { 
				public void itemStateChanged(java.awt.event.ItemEvent e) {    
					System.out.println("itemStateChanged()"); // TODO Auto-generated Event stub itemStateChanged()
                    // Cambiar el estado del CheckBox
                    initSelectedItemsJCheckBox();
                    // Cambiar el estado del jComboBox1
                    DefaultComboBoxModel defaultModel = new DefaultComboBoxModel(getFieldNames());
                    jComboBox1.setModel(defaultModel);
				}
			});
		}
		return jComboBox;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setBounds(126, 200, 208, 21);
		}
		return jTextField;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText(PluginServices.getText(this,"Abrir"));
			jButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
                    JFileChooser jfc = new JFileChooser();
                    jfc.addChoosableFileFilter(new GenericFileFilter("shp", "Ficheros SHP"));
                    if (jfc.showSaveDialog((Component) PluginServices.getMainFrame()) == JFileChooser.APPROVE_OPTION) {
                        File file = jfc.getSelectedFile();
                        if (!(file.getPath().endsWith(".shp") || file.getPath().endsWith(".SHP"))){
                            file = new File(file.getPath()+".shp");
                        }
                    }
                    if (jfc.getSelectedFile()!=null) getJTextField().setText(jfc.getSelectedFile().getAbsolutePath());
				}
			});
			jButton.setBounds(341, 200, 59, 21);
		}
		return jButton;
	}
	private void confButtonGroup() {
		if (buttonGroup == null) {
			buttonGroup = new ButtonGroup();
			buttonGroup.add(getJRadioButton());
			buttonGroup.add(getJRadioButton1());
		}
	}
	/**
	 * This method initializes jRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getJRadioButton() {
		if (jRadioButton == null) {
			jRadioButton = new JRadioButton();
			jRadioButton.setText(PluginServices.getText(this,"Area_de_influencia_definida_por_una_distancia") + ":");
			jRadioButton.setBounds(4, 86, 261, 21);
			jRadioButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					getJTextField1().setEnabled(true);
					getJComboBox1().setEnabled(false);
				}
			});
		}
		return jRadioButton;
	}
	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setBounds(275, 86, 127, 21);
		}
		return jTextField1;
	}
	/**
	 * This method initializes jRadioButton1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getJRadioButton1() {
		if (jRadioButton1 == null) {
			jRadioButton1 = new JRadioButton();
			jRadioButton1.setText(PluginServices.getText(this,"Area_de_influencia_definida_por_un_campo") + ":");
			jRadioButton1.setBounds(4, 112, 250, 21);
			jRadioButton1.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					getJTextField1().setEnabled(false);
					getJComboBox1().setEnabled(true);
				}
			});
		}
		return jRadioButton1;
	}
	/**
	 * This method initializes jComboBox1	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJComboBox1() {
		if (jComboBox1 == null) {
            jComboBox1 = new JComboBox();
            DefaultComboBoxModel defaultModel = new DefaultComboBoxModel(getFieldNames());
            jComboBox1.setModel(defaultModel);
			jComboBox1.setBounds(262, 112, 140, 21);
		}
		return jComboBox1;
	}
    /**
     * @return Returns the outputFile.
     */
    public File getOutputFile() {
        return new File(getJTextField().getText());
    }
    /**
     * This method initializes endType	
     * 	
     * @return javax.swing.JComboBox	
     */    
    private JComboBox getEndType() {
    	if (endType == null) {
    		endType = new JComboBox();
            String[] endTypes = new String[]{"2", "4", "8", "12", "16", "20", "24", "28", "32"};
            DefaultComboBoxModel defaultModel = new DefaultComboBoxModel(endTypes);
            endType.setModel(defaultModel);
    		endType.setBounds(229, 144, 84, 21);
    	}
    	return endType;
    }
    /**
     * This method initializes dissolveEntitiesJCheckBox	
     * 	
     * @return javax.swing.JCheckBox	
     */    
    private JCheckBox getDissolveEntitiesJCheckBox() {
    	if (dissolveEntitiesJCheckBox == null) {
    		dissolveEntitiesJCheckBox = new JCheckBox();
    		dissolveEntitiesJCheckBox.setBounds(4, 170, 190, 21);
    		dissolveEntitiesJCheckBox.setText(PluginServices.getText(this,"Disolver_entidades"));
    	}
    	return dissolveEntitiesJCheckBox;
    }
    
    /**
     * This method returns the name of the layer selected at the first ComboBox.
     * @return
     */
    public String getSelectedLayerName() {
        return ((String)getJComboBox().getSelectedItem());
    }
}  //  @jve:decl-index=0:visual-constraint="10,10"
